<p-toast></p-toast>
<p-table #dt
  [value]="books"
  [rowHover]="true"
  [lazy]="true"
  (onLazyLoad)="loadBooks($event)"
  responsiveLayout="scroll"
  [paginator]="true"
  [rows]="10"
  [totalRecords]="totalBooks"
  [loading]="loading"
  styleClass="p-datatable-sm"
  [globalFilterFields]="['isbn','title', 'publisherName', 'publishedYear','price']"
>

  <ng-template pTemplate="header">
      <tr>
          <th>ISBN</th>
          <th>Title</th>
          <th>Publisher</th>
          <th>Published</th>
          <th>Price</th>
      </tr>
      <tr>
        <th>
            <input pInputText type="text" (input)="search($event, 'isbn')"  placeholder="Search by Isbn" class="p-column-filter">
        </th>
        <th>
            <input pInputText type="text" (input)="search($event, 'title')" placeholder="Search by Title" class="p-column-filter">
        </th>
        <th>
            <input pInputText type="text" (input)="search($event, 'publisherName')"  placeholder="Search by Publisher " class="p-column-filter">
        </th>
        <th>
            <input pInputText type="number" (input)="search($event, 'publishedYear')" placeholder="Search by > Year" class="p-column-filter">
        </th>
        <th>
          <input pInputText type="number" (input)="search($event, 'price')" placeholder="Search by > Price" class="p-column-filter">
        </th>
    </tr>
  </ng-template>
  <ng-template pTemplate="body" let-book>
      <tr>
          <td>{{book.isbn}}</td>
          <td>{{book.title}}</td>
          <td>{{book.publisherName}}</td>
          <td>{{book.publishedYear}}</td>
          <td>{{book.price}}</td>
          <td>
            <button pButton pRipple type="button" icon="pi pi-pencil" class="p-button-rounded p-button-success" (click)="updateBook(book)"></button>
            <button pButton pRipple type="button" icon="pi pi-trash" class="p-button-rounded p-button-danger" (click)="deleteBook(book)"></button>
          </td>
      </tr>
  </ng-template>
</p-table>

<p-confirmDialog [style]="{width: '50vw'}" key="positionDialog" [position]="'top'" [baseZIndex]="10000" rejectButtonStyleClass="p-button-outlined"></p-confirmDialog>
